#ifndef SCREEM_TAG_TREE_H
#define SCREEM_TAG_TREE_H

#include <glib/ghash.h>

#include <gtk/gtkhbox.h>
#include <gtk/gtktreestore.h>

#include <libxml/tree.h>

#include "screem-dtd.h"

#include "screem-window.h"

#define SCREEM_TYPE_TAG_TREE  (screem_tag_tree_get_type())
#define SCREEM_TAG_TREE(obj)  (G_TYPE_CHECK_INSTANCE_CAST( ( obj ), SCREEM_TYPE_TAG_TREE, \
                                                ScreemTagTree ) )
#define SCREEM_TAG_TREE_CLASS(klass)  (G_TYPE_CHECK_CLASS_CAST( ( klass ), \
                                                             SCREEM_TYPE_TAG_TREE, \
                                                             ScreemTagTreeClass ) )
#define SCREEM_IS_TAG_TREE(obj)  (G_TYPE_CHECK_INSTANCE_TYPE( ( obj ), SCREEM_TYPE_TAG_TREE ) )

typedef struct {
	GtkHBox parent;
	
	xmlDocPtr tree;
	GtkWidget *view;

	GtkTreeStore *store;

	GHashTable *paths;

	ScreemWindow *window;
} ScreemTagTree;

typedef struct {
	GtkHBoxClass parent_class;

} ScreemTagTreeClass;

GType screem_tag_tree_get_type( void );
ScreemTagTree *screem_tag_tree_new( void );

void screem_tag_tree_add_dtd( ScreemTagTree *tree, ScreemDTD *dtd );

#endif
